package cz.muni.fi.pb162.test3;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

public class JavaStudentsAndTeachersTest extends junit.framework.TestCase
{    
     JavaTeacher ab;
     JavaTeacher cd;
     JavaStudent ef1;
     JavaStudent gh2;
     JavaStudent ij3;
     JavaStudent ik4;

    public JavaStudentsAndTeachersTest()
    {
    }

    protected void setUp(){
        ab = new JavaTeacherImpl(new String("b"), new String("a"), 1);
        cd = new JavaTeacherImpl(new String("d"), new String("c"), 3);
        ef1 = new JavaStudentImpl(new String("f"), new String("e"));
        gh2 = new JavaStudentImpl(new String("h"), new String("g"));
        ij3 = new JavaStudentImpl(new String("j"), new String("i"));
        ik4 = new JavaStudentImpl(new String("k"), new String("i"));
    }

    protected void tearDown()
    {
    }

    public void testNewStudent(){
        try {
            new JavaStudentImpl(null, "a");
            fail("Lze vytvorit studenta, jehoz jmeno ma null");
        } catch(NullPointerException ex) {
        }
        try {
            new JavaStudentImpl("a", null);
            fail("Lze vytvorit studenta, jehoz prijmeni ma null");
        } catch(NullPointerException ex) {
        }
    }
    
    public void testStudentHasTeacher(){    
        assertFalse("Na pocatku nema student ucitele... ", ef1.hasTeacher());
    }
    
    public void testStudentAcceptAndHasTeacher(){
        ef1.accept();
        assertTrue("Ted uz by student mel mit ucitele... ", ef1.hasTeacher());
    }

    public void testAcceptTwice(){
        ef1.accept();
        try {
            ef1.accept();
            fail("Bylo ocekavana vyjimka IllegalStateException");
        } catch(IllegalStateException ex) {
            // All is ok
        }
    }

    public void testStudentToString() {
        assertEquals("f e", ef1.toString());
        assertEquals("h g", gh2.toString());
    }

    public void testStudentEquals() {
        assertTrue(new JavaStudentImpl("a","b").equals(new JavaStudentImpl("a","b")));
        assertTrue(new JavaStudentImpl("a","b").equals(new JavaStudentImpl("A","B")));
        assertTrue(new JavaStudentImpl("a","b").equals(new JavaStudentImpl("A","b")));
        assertTrue(new JavaStudentImpl("a","b").equals(new JavaStudentImpl("a","B")));
        assertFalse(new JavaStudentImpl("a","b").equals(new JavaStudentImpl("a","c")));
    }

    public void testStudentHashcode() {
        assertTrue(new JavaStudentImpl("a","b").hashCode() == new JavaStudentImpl("a","b").hashCode());
        assertTrue(new JavaStudentImpl("a","b").hashCode() == new JavaStudentImpl("A","B").hashCode());
        assertTrue(new JavaStudentImpl("a","b").hashCode() == new JavaStudentImpl("A","b").hashCode());
        assertTrue(new JavaStudentImpl("a","b").hashCode() == new JavaStudentImpl("a","B").hashCode());
    }

    
    public void testTeacherToString() {
        JavaTeacher testTeacher = new JavaTeacherImpl("a","b",10);
        assertEquals("b a, []", ab.toString());
        assertEquals("d c, []", cd.toString());
        assertEquals("a b, []", testTeacher.toString());
        testTeacher.becomeHisStudent(new JavaStudentImpl("A","B"));
        assertEquals("a b, [A B]", testTeacher.toString());
        testTeacher.becomeHisStudent(new JavaStudentImpl("X","B"));
        assertEquals("a b, [A B, X B]", testTeacher.toString());
        testTeacher.becomeHisStudent(new JavaStudentImpl("a","C"));
        assertEquals("a b, [A B, a C, X B]", testTeacher.toString());
        testTeacher.becomeHisStudent(new JavaStudentImpl("A","d"));
        assertEquals("a b, [A B, a C, A d, X B]", testTeacher.toString());
    }
    
    public void testTeacherCapcity() {
        assertEquals(1, ab.capacity());
        assertEquals(3, cd.capacity());
    }

    public void testTeacherNumberOfStudents() {
        assertEquals(0, ab.numberOfStudents());
        assertEquals(0, cd.numberOfStudents());
        cd.becomeHisStudent(ef1);
        assertEquals(1, cd.numberOfStudents());
        cd.becomeHisStudent(gh2);
        assertEquals(2, cd.numberOfStudents());
    }
    
    public void testTeacherGetStudents() {
        assertEquals(Collections.EMPTY_SET, cd.getStudents());
        cd.becomeHisStudent(ef1);
        Set<JavaStudent> s = new HashSet<JavaStudent>();
        s.add(ef1);
        assertEquals(s, cd.getStudents());
        cd.becomeHisStudent(gh2);
        s.add(gh2);
        assertEquals(s, cd.getStudents());
        Set<JavaStudent> s2 = cd.getStudents();
        try {
            s2.clear();
            fail("getStudents nevraci read-only kolekci");
        } catch(UnsupportedOperationException ex) {
        }
    }
    
    public void testNullPointerArgument(){
        try{
	        ab.becomeHisStudent(null);
	        fail("Metoda becomeHisStuden() nevyhodi vyjimku, " +
		         "NullPointerException, prestoze mela.");
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Mela se vyhodit vyjimka ManyJavaStudentsrException.");
	    }catch(
	        NullPointerException npe
	    ){
	        assertTrue("Mela se vyhodit vyjimka NullPointerException.", true);
        }
    }
        
    public void testTooManyStudents1(){
        try{
	        ab.becomeHisStudent(null);
	        assertTrue("Mela se vyhodit vyjimka NullPointerException.", true);
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Mela se vyhodit vyjimka ManyJavaStudentsrException.");
	    }catch(
	        NullPointerException npe
	    ){
	        assertTrue("Mela se vyhodit vyjimka NullPointerException.", true);
        }
        try{
	        ab.becomeHisStudent(ef1);
	        assertTrue(ef1 + " mel byt akceptovan.", true);
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
	    }catch(
	        NullPointerException npe
	    ){
	        fail("Nemela se vyhodit vyjimka NullPointerException.");
        }
    }

    public void testTooManyStudents2(){
        try{
	        ab.becomeHisStudent(ef1);
	        assertTrue(ef1 + " mel byt akceptovan.", true);
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
	    }catch(
	        NullPointerException npe
	    ){
	        fail("Nemela se vyhodit vyjimka NullPointerException.");
        }
        try{
	        ab.becomeHisStudent(gh2);
	        fail(gh2 + " jiz nemel byt akceptovan.");
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        assertTrue("Mela se vyhodit vyjimka ManyJavaStudentsException.", true);
	    }catch(
	        NullPointerException npe
	    ){
	        fail("Nemela se vyhodit vyjimka NullPointerException.");
        }
    }
    
    public void testTooManyTeachers(){
        try{
	        ab.becomeHisStudent(ef1);
	        assertTrue(ef1 + " mel byt akceptovan.", true);
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
	    }catch(
	        NullPointerException npe
	    ){
	        fail("Nemela se vyhodit vyjimka NullPointerException.");
        }
        try{
	        cd.becomeHisStudent(ef1);
	        fail(ef1 + " nemel byt akceptovan.");
	    }catch(
	        ManyJavaTeachersException mjte
	    ){
	        assertTrue("Mela se vyhodit vyjimka ManyJavaTeachersException.", true);
	    }catch(
	        ManyJavaStudentsException mjse
	    ){
	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
	    }catch(
	        NullPointerException npe
	    ){
	        fail("Nemela se vyhodit vyjimka NullPointerException.");
        }
    }
    
//    public void testListOdStudents1(){
//        StringBuffer rSB;
//        String rS;
//        int i;
//        
//        rSB = new StringBuffer(20);
//        
//        try{
//	        cd.becomeHisStudent(ij3);
//	        assertTrue(ij3 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }       
//        try{
//	        cd.becomeHisStudent(gh2);
//	        assertTrue(gh2 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }
//        
//        rS = cd.listOfStudents();
//        for(i = 0; i < rS.length(); ++i)
//	        if(
//	            (rS.charAt(i) != ' ') && (rS.charAt(i) != '\n')
//	        ){
//	            rSB.append(rS.charAt(i));
//	        }
//	    rS = rSB.toString();
//
//        assertEquals("Studenti v seznamu jsou podle prijmeni spatne setrideni.", "uciteldcseznamjehostudentu:hgji", rS);
//        
//    }
//    
//    public void testListOdStudents2(){
//        StringBuffer rSB;
//        String rS;
//        int i;
//        
//        rSB = new StringBuffer(20);
//        
//        try{
//	        cd.becomeHisStudent(ik4);
//	        assertTrue(ik4 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }       
//        try{
//	        cd.becomeHisStudent(ij3);
//	        assertTrue(ij3 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }       
//        try{
//	        cd.becomeHisStudent(gh2);
//	        assertTrue(gh2 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }
//        
//        rS = cd.listOfStudents();
//        for(i = 0; i < rS.length(); ++i)
//	        if(
//	            (rS.charAt(i) != ' ') && (rS.charAt(i) != '\n')
//	        ){
//	            rSB.append(rS.charAt(i));
//	        }
//	    rS = rSB.toString();
//
//        assertEquals("Studenti v seznamu pri stejnem prijmeni jsou podle jmena spatne setrideni.", "uciteldcseznamjehostudentu:hgjiki", rS);
//        
//    }
//    
//    public void testListOdStudents3(){
//        try{
//	        cd.becomeHisStudent(ij3);
//	        assertTrue(ij3 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }       
//        try{
//	        cd.becomeHisStudent(gh2);
//	        assertTrue(gh2 + " mel byt akceptovan.", true);
//	    }catch(
//	        ManyJavaTeachersException mjte
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaTeachersException.");
//	    }catch(
//	        ManyJavaStudentsException mjse
//	    ){
//	        fail("Nemela se vyhodit vyjimka ManyJavaStudentsException.");
//	    }catch(
//	        NullPointerException npe
//	    ){
//	        fail("Nemela se vyhodit vyjimka NullPointerException.");
//        }
//        assertEquals("Vypis nema dobre mezery nebo odradkovani (' ' | '\\n')", "ucitel d c\nseznam jeho studentu:\n   h g\n   j i\n\n", cd.listOfStudents());
//        
//    }
}
