package cz.muni.fi.pb162.test3;

import java.util.Set;

/**
 * Toto rozhrani reprezentuje ucitele. Ucitel muze ucit urcity omezeny pocet 
 * studentu. Ma konstruktor, ktery ma tri parametry; jmeno ucitele, prijmeni 
 * ucitele (ani jedno nesmi byt null) a jeho kapacita (kladne cele cislo).
 */
public interface JavaTeacher{
    
    /**
     * Vrati true, pokud je dany student studentem u tohoto ucitele.
     *
     * @param student student, ktery nas zajima
     * @return true, pokud je dany student studentem u tohoto ucitele
     */
    public boolean isHisStudent(JavaStudent student);
    
    /**
     * Vrati aktualni pocet studentu.
     *
     * @return aktualni pocet studentu
     */
    public int numberOfStudents();
    
    /**
     * Vrati maximalni pocet studentu, ktere tento ucitel muze ucit
     *
     * @return maximalni pocet studentu
     */
    public int capacity();
    
    /**
     * Daneho studenta zaradi k tomuto uciteli.
     * @param student student, ktery ma byt prirazen k uciteli
     * @throws cz.muni.fi.pb162.test3.ManyJavaTeachersException pokud uz student ucitele prirazeneho ma
     * @throws cz.muni.fi.pb162.test3.ManyJavaStudentsException pokud ma uz ucitel vycerpanou svoji kapacitu
     * @throws NullPointerException pokud je student null
     */
    public void becomeHisStudent(JavaStudent student) throws 
            ManyJavaTeachersException, ManyJavaStudentsException;
    
    /**
     * Vrati seznam studentu daneho ucitele.
     * @return seznam studentu.
     */
    public Set<JavaStudent> getStudents();
    
    /**
     * Vrati jmeno a prijmeni ucitele, potom carku, mezeru a seznam studentu
     * serazeny podle abecedy ve formatu [Prvni Student, Druhy Student].
     *
     * @return retezec v predepsanem tvaru.
     */
    public String toString();    
 
}
